local _G = GLOBAL
local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local TECH = GLOBAL.TECH
GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})


PrefabFiles = {
	"edwardelric",
    "resurr_edward",
    "bluelight"
    }

Assets = {

    Asset("ATLAS", "images/inventoryimages/resurr_edward.xml"),
    Asset("IMAGE", "images/inventoryimages/resurr_edward.tex"),

    Asset( "IMAGE", "bigportraits/edwardelric.tex"),
    Asset( "ATLAS", "bigportraits/edwardelric.xml"),

    Asset( "IMAGE", "images/saveslot_portraits/edwardelric.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/edwardelric.xml" ),

    Asset( "IMAGE", "images/avatars/self_inspect_edwardelric.tex" ),
    Asset( "ATLAS", "images/avatars/self_inspect_edwardelric.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/edwardelric.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/edwardelric.xml" ),
    
    Asset( "IMAGE", "images/selectscreen_portraits/edwardelric_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/edwardelric_silho.xml" ),
    
	Asset( "IMAGE", "images/map_icons/edwardelric.tex" ),
	Asset( "ATLAS", "images/map_icons/edwardelric.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_edwardelric.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_edwardelric.xml" ), 

	Asset( "ATLAS", "images/hud/edwardelrictab.xml"),
	Asset( "IMAGE", "images/hud/edwardelrictab.tex" ),

    Asset( "ATLAS", "images/hud/recasttab.xml"),
    Asset( "IMAGE", "images/hud/recasttab.tex" ), 

    Asset( "ATLAS", "images/hud/recasttab2.xml"),
    Asset( "IMAGE", "images/hud/recasttab2.tex" ), 

    Asset("SOUNDPACKAGE", "sound/pailide.fev"),
    Asset("SOUND", "sound/pailide.fsb") 
}

STRINGS.CHARACTERS.EDWARDELRIC = require "speech_wilson"

table.insert(GLOBAL.CHARACTER_GENDERS.FEMALE, "edwardelric")

AddMinimapAtlas("images/map_icons/edwardelric.xml")


AddModCharacter("edwardelric")

modimport("scripts/newaction.lua")

TUNING.SKILL_ONE1 = GetModConfigData("skill_one1")
TUNING.SKILL_ONE2 = GetModConfigData("skill_one2")

TUNING.SKILL_TWO1 = GetModConfigData("skill_two1")
TUNING.SKILL_TWO2 = GetModConfigData("skill_two2")

TUNING.SKILL_THREE1 = GetModConfigData("skill_three1")
TUNING.SKILL_THREE2 = GetModConfigData("skill_three2")

TUNING.SKILL_FOUR = GetModConfigData("skill_four")

STRINGS.CHARACTER_TITLES.edwardelric = "爱德华.艾尔利克"
STRINGS.CHARACTER_NAMES.edwardelric = "爱德华.艾尔利克"
STRINGS.CHARACTER_DESCRIPTIONS.edwardelric= "*拍立得炼金术\n*可以用石头或铥矿石碎片制造墙壁\n*自带一本科技、可以读书，但不能写书"
STRINGS.CHARACTER_QUOTES.edwardelric= "钢之炼金术师的主角爱德华·艾尔利克\n在一次人体炼成中被真理之门带入到饥荒世界中。\n注：半数以上的炼金术存在副产物，制作栏不显示，直接出现在物品栏。\n禁忌炼金和人体炼成有副作用"

RECIPETABS.EDWARDELRIC = {str = "EDWARDELRIC", sort = 50, icon = "edwardelrictab.tex", icon_atlas = "images/hud/edwardelrictab.xml"}
RECIPETABS.EDWARDELRIC2 = {str = "EDWARDELRIC2", sort = 51, icon = "recasttab.tex", icon_atlas = "images/hud/recasttab.xml"}
RECIPETABS.EDWARDELRIC3 = {str = "EDWARDELRIC3", sort = 52, icon = "recasttab2.tex", icon_atlas = "images/hud/recasttab2.xml"}

STRINGS.TABS.EDWARDELRIC = "等价炼金"
STRINGS.TABS.EDWARDELRIC2 = "禁忌炼成"
STRINGS.TABS.EDWARDELRIC3 = "人体炼成"
---------------------------------------------
STRINGS.RECIPE_DESC.LOG = "这算是等价交换吗." 
STRINGS.RECIPE_DESC.ROCKS = "这算是等价交换吗." 
STRINGS.RECIPE_DESC.CUTGRASS = "这算是等价交换吗." 
STRINGS.RECIPE_DESC.TWIGS = "这算是等价交换吗." 
STRINGS.RECIPE_DESC.ICE = "这算是等价交换吗." 
STRINGS.RECIPE_DESC.TWIGS = "这算是等价交换吗." 
STRINGS.RECIPE_DESC.CUTREEDS = "这算是等价交换吗." 
STRINGS.RECIPE_DESC.SILK = "这算是等价交换吗."
STRINGS.RECIPE_DESC.HONEYCOMB = "这算是等价交换吗." 
STRINGS.RECIPE_DESC.BUTTER = "这算是等价交换吗." 
STRINGS.RECIPE_DESC.PIGSKIN = "这算是等价交换吗."
STRINGS.RECIPE_DESC.GUANO = "这算是等价交换吗." 
STRINGS.RECIPE_DESC.LIGHTBULB = "这算是等价交换吗."

------------------------------------------------
STRINGS.RECIPE_DESC.GOLDNUGGET = "炼成金子是非法的，答应我只有这一次好吗."
STRINGS.RECIPE_DESC.MARBLE = "大理石在这个世界似乎很珍贵."
STRINGS.RECIPE_DESC.GEARS = "我想温蒂了."
STRINGS.RECIPE_DESC.REDGEM = "又一颗假的贤者之石."
STRINGS.RECIPE_DESC.BLUEGEM = "它和温蒂的眼睛一样美."
STRINGS.RECIPE_DESC.LIVINGLOG = "如果阿尔也能来到这个世界就好了."
STRINGS.RECIPE_DESC.THULECITE_PIECES = "解析这玩意的构成可花了我不少时间."

-------------------------------------------

STRINGS.NAMES.RESURR_EDWARD = "人体炼成阵"   
STRINGS.RECIPE_DESC.RESURR_EDWARD = "Don't Forget 3.OCT.11"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.RESURR_EDWARD = "Don't Forget 3.OCT.11"

---------------------等价炼金配方
local log_recipes = Recipe("twigs", {Ingredient("boards", 1)}, RECIPETABS.EDWARDELRIC, TECH.NONE, nil, nil, nil, nil, 16)
local twigs_recipes = Recipe("log", {Ingredient("twigs", 4)}, RECIPETABS.EDWARDELRIC, TECH.NONE)
local rocks_recipes = Recipe("rocks", {Ingredient("cutstone", 1)}, RECIPETABS.EDWARDELRIC, TECH.NONE, nil, nil, nil, nil, 3)
local cutgrass_recipes = Recipe("cutgrass", {Ingredient("rope", 1)}, RECIPETABS.EDWARDELRIC, TECH.NONE, nil, nil, nil, nil, 3)
local log_recipes = Recipe("log", {Ingredient("twigs", 4)}, RECIPETABS.EDWARDELRIC, TECH.NONE)
local ice_recipes = Recipe("ice", {Ingredient("log", 3)}, RECIPETABS.EDWARDELRIC, TECH.NONE)
local cutreeds_recipes = Recipe("cutreeds", {Ingredient("cutgrass", 5)}, RECIPETABS.EDWARDELRIC, TECH.NONE)
local silk_recipes = Recipe("silk", {Ingredient("bird_egg", 3)}, RECIPETABS.EDWARDELRIC, TECH.NONE, nil, nil, nil, nil, 3)
local honeycomb_recipes = Recipe("honeycomb", {Ingredient("honey", 10), Ingredient("log", 1)}, RECIPETABS.EDWARDELRIC, TECH.NONE)
local butter_recipes = Recipe("butter", {Ingredient("honey", 4), Ingredient("smallmeat", 1)}, RECIPETABS.EDWARDELRIC, TECH.NONE)
local pigskin_recipes = Recipe("pigskin", {Ingredient("monstermeat", 4), Ingredient("smallmeat", 1), Ingredient("silk", 2)}, RECIPETABS.EDWARDELRIC, TECH.NONE)
local guano_recipes = Recipe("guano", {Ingredient("spoiled_food", 1), Ingredient("monstermeat", 1)}, RECIPETABS.EDWARDELRIC, TECH.NONE)
local lightbulb_recipes = Recipe("lightbulb", {Ingredient("bird_egg", 3), Ingredient("flint", 1), Ingredient("nitre", 1)}, RECIPETABS.EDWARDELRIC, TECH.NONE)

---------------------禁忌炼金配方
local goldnugget_recipes = Recipe("goldnugget", {Ingredient("flint", 2), Ingredient("nitre", 1), Ingredient("rocks", 4)}, RECIPETABS.EDWARDELRIC2, TECH.NONE)
local marble_recipes = Recipe("marble", {Ingredient("houndstooth", 3), Ingredient("monstermeat", 4), Ingredient("rocks", 5)}, RECIPETABS.EDWARDELRIC2, TECH.NONE)
local gears_recipes = Recipe("gears", {Ingredient("meat", 2), Ingredient("monstermeat", 3), Ingredient("rocks", 5)}, RECIPETABS.EDWARDELRIC2, TECH.NONE)
local redgem_recipes = Recipe("redgem", {Ingredient("feather_robin", 3), Ingredient("berries", 3), Ingredient("rocks", 2)}, RECIPETABS.EDWARDELRIC2, TECH.NONE)
local bluegem_recipes = Recipe("bluegem", {Ingredient("feather_robin_winter", 3), Ingredient("blue_cap", 1), Ingredient("rocks", 2)}, RECIPETABS.EDWARDELRIC2, TECH.NONE)
local thulecite_pieces_recipes = Recipe("thulecite_pieces", {Ingredient("marble", 2), Ingredient("goldnugget", 2), Ingredient("nightmarefuel", 2)}, RECIPETABS.EDWARDELRIC2, TECH.NONE, nil, nil, nil, nil, 6)
--local livinglog_recipes = Recipe("livinglog", {Ingredient(CHARACTER_INGREDIENT.HEALTH, 25), Ingredient(CHARACTER_INGREDIENT.SANITY, 20)}, RECIPETABS.EDWARDELRIC2, TECH.NONE)
local livinglog2_recipes = Recipe("livinglog", {Ingredient("log", 1), Ingredient("nightmarefuel", 3)}, RECIPETABS.EDWARDELRIC2, TECH.NONE)

---------------------人体炼金配方
local resurr_edward_recipes = Recipe("resurr_edward", {Ingredient("ice", 10), Ingredient("poop", 6), Ingredient("marble", 4), Ingredient("nitre", 2)}, RECIPETABS.EDWARDELRIC3, TECH.NONE, RECIPE_GAME_TYPE.COMMON, "resurr_edward_placer")
resurr_edward_recipes.atlas = "images/inventoryimages/resurr_edward.xml"

AddPrefabPostInit("wall_stone", function(inst)
    inst.animbuild = false
     
    local function OnSave(inst, data)
        data.animbuild = inst.animbuild
    end   

    local function OnPreload(inst, data)
        if data and data.animbuild then
            inst.animbuild = data.animbuild
            inst.AnimState:SetBuild("wall_ruins")
        end 
    end   

    inst.OnSave = OnSave  --保存相关数据
    inst.OnPreLoad = OnPreload       
end)

ACTIONS.PLANT.distance = 12
--ACTIONS.PLANTONGROWABLE.distance = 12
ACTIONS.FERTILIZE.distance = 12

--[[
ACTIONS.DEPLOY = Action({}, 0, nil, nil, 12)
ACTIONS.DEPLOY_AT_RANGE = Action({},0, nil, nil, 12)
]]
ACTIONS.PLANT.fn = function(act)
    if act.doer.components.inventory then
	    local seed = act.doer.components.inventory:RemoveItem(act.invobject)
	    if seed then
	        if act.target.components.grower:PlantItem(seed) then
	        	SpawnPrefab("bluelight").Transform:SetPosition(act.target.Transform:GetWorldPosition())
	            return true
	        else
	            act.doer.components.inventory:GiveItem(seed)
	        end
	    end
   end
end
----------------
ACTIONS.DEPLOY.fn = function(act)
	if act.invobject and act.invobject.components.deployable and act.invobject.components.deployable:CanDeploy(act.pos, true) then
		local obj = (act.doer.components.inventory and act.doer.components.inventory:RemoveItem(act.invobject)) or 
		(act.doer.components.container and act.doer.components.container:RemoveItem(act.invobject))
		if obj then
			if obj.components.deployable:Deploy(act.pos, act.doer) then
				SpawnPrefab("bluelight").Transform:SetPosition(act.pos:Get())
				return true
			else
				act.doer.components.inventory:GiveItem(obj)
			end
		end
	end
end

-----------------------------------
ACTIONS.FERTILIZE.fn = function(act)
	if not act.target and act.doer:HasTag("healonfertilize") and act.invobject then

		if  act.doer.components.health then
		    act.doer.components.health:DoDelta(2,false,"fertilize")
		    
		    if act.invobject.components.stackable and act.invobject.components.stackable.stacksize > 1 then
		        act.invobject.components.stackable:Get():Remove()
		    else
		    	if act.invobject.components.finiteuses then
		    		act.invobject.components.finiteuses:Use(2)
		    	else
		        	act.invobject:Remove()
		    	end
		    end
		    
		    return true
		end

	elseif act.invobject and act.invobject.components.fertilizer then
		if act.target and act.target.components.crop and not act.target.components.crop:IsReadyForHarvest() and not act.target.components.crop:IsWithered() then
			local obj = act.invobject

			if act.target.components.crop:Fertilize(obj) then
				  SpawnPrefab("bluelight").Transform:SetPosition(act.target.Transform:GetWorldPosition())
				return true
			else
				return false
			end
		elseif act.target.components.grower and act.target.components.grower:IsEmpty() then
			local obj = act.invobject
			act.target.components.grower:Fertilize(obj)
			SpawnPrefab("bluelight").Transform:SetPosition(act.target.Transform:GetWorldPosition())
			return true
		elseif act.target.components.pickable and act.target.components.pickable:CanBeFertilized() then

			if act.target.components.pickable and act.target.components.pickable.pickydirt then
				local pt = Vector3(act.target.Transform:GetWorldPosition())
				local tile = GetWorld().Map:GetTileAtPoint(pt.x, pt.y, pt.z)
				local okdirt = false
				for i,tiletype in ipairs(act.target.components.pickable.pickydirt)do
					if tile == tiletype then
						okdirt = true
					end
				end
				if not okdirt then
					return false, "WRONGDIRT"
				end
			end

			local obj = act.invobject
			act.target.components.pickable:Fertilize(obj)
			SpawnPrefab("bluelight").Transform:SetPosition(act.target.Transform:GetWorldPosition())
			return true		
		elseif act.target.components.hackable and act.target.components.hackable:CanBeFertilized() then
			local obj = act.invobject
			act.target.components.hackable:Fertilize(obj)
			SpawnPrefab("bluelight").Transform:SetPosition(act.target.Transform:GetWorldPosition())
			return true     
		end
	end
end
