GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})

local newstates = 
{
    State{
        name = "pailide",
        tags = {"doing", "busy"},
        
        timeline=
        {
            TimeEvent(35*FRAMES, function( inst )
                   SpawnPrefab("bluelight").Transform:SetPosition(inst.Transform:GetWorldPosition())
                   inst.components.playercontroller:ShakeCamera(inst, "VERTICAL", 0.3, 0.01, 0.6, 30)
            end),

            TimeEvent(37*FRAMES, function( inst )
                   inst:PerformBufferedAction() 
                   inst.sg:RemoveStateTag("busy")               
            end),
        },
        
        onenter = function(inst, timeout)
            local targ = inst:GetBufferedAction() and inst:GetBufferedAction().target or nil
            if targ then targ:PushEvent("startlongaction") end
            
            inst.components.locomotor:Stop()

            inst.SoundEmitter:PlaySound("pailide/sfx/pailide")  --播放音效

            if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil then
                 inst.AnimState:Hide("ARM_carry") --隐藏持物手
                 inst.AnimState:Show("ARM_normal") --显示普通的手
            end 

            inst.AnimState:AddOverrideBuild("pailide_hand")
            GetPlayer().AnimState:PlayAnimation("pailide", false)
        end,

        onexit = function(inst)
                    if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil then
                          inst.AnimState:Hide("ARM_normal") --隐藏持物手
                          inst.AnimState:Show("ARM_carry") --显示普通的手
                    end
        end,        

        events=
        {
            EventHandler("animover", function(inst)				
                  inst.sg:GoToState("idle")
                    if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil then
                          inst.AnimState:Hide("ARM_normal") --隐藏持物手
                          inst.AnimState:Show("ARM_carry") --显示普通的手
                    end
            end ),
        },
    },

    State{
        name = "pailide_short",  --快速施法
        tags = {"doing", "busy"},
        
        timeline=
        {
            TimeEvent(25*FRAMES, function( inst )
                   SpawnPrefab("bluelight").Transform:SetPosition(inst.Transform:GetWorldPosition())
                   --inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/lightninggoat/jacobshorn")  --电击音效
                   inst.components.playercontroller:ShakeCamera(inst, "VERTICAL", 0.3, 0.01, 0.6, 30)
                   --local pr = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0, 1, 0)
            end),

            TimeEvent(30*FRAMES, function( inst )
                   inst:PerformBufferedAction() 
                   inst.sg:RemoveStateTag("busy")               
            end),
        },
        
        onenter = function(inst, timeout)
            local targ = inst:GetBufferedAction() and inst:GetBufferedAction().target or nil
            if targ then targ:PushEvent("startlongaction") end
            
           -- inst.sg:SetTimeout(timeout or 1)
            inst.components.locomotor:Stop()

            inst.SoundEmitter:PlaySound("pailide/sfx/pailide")  --播放音效

            if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil then
                 inst.AnimState:Hide("ARM_carry") --隐藏持物手
                 inst.AnimState:Show("ARM_normal") --显示普通的手
            end 

            inst.AnimState:SetDeltaTimeMultiplier(1.2) --动画播放速度加速20%
            inst.AnimState:AddOverrideBuild("pailide_hand")
            GetPlayer().AnimState:PlayAnimation("pailide", false)
        end,

        onexit = function(inst)
                    inst.AnimState:SetDeltaTimeMultiplier(1) --动画恢复正常速度

                    if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil then
                          inst.AnimState:Hide("ARM_normal") --隐藏持物手
                          inst.AnimState:Show("ARM_carry") --显示普通的手
                    end
        end,        

        events=
        {
            EventHandler("animover", function(inst)       
                  inst.sg:GoToState("idle")
                    if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil then
                          inst.AnimState:Hide("ARM_normal") --隐藏持物手
                          inst.AnimState:Show("ARM_carry") --显示普通的手
                    end
            end ),
        },
    },

    State{
        name = "pailide_hammer",
        tags = {"prehammer", "hammering", "working"},

        onenter = function(inst)
            inst.sg.statemem.action = inst:GetBufferedAction()
            inst.components.locomotor:Stop()

            inst.SoundEmitter:PlaySound("pailide/sfx/pailide")  --播放音效
            
			if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil then
                 inst.AnimState:Hide("ARM_carry") --隐藏持物手
                 inst.AnimState:Show("ARM_normal") --显示普通的手
            end
			
            inst.AnimState:AddOverrideBuild("pailide_hand")
            inst.AnimState:PlayAnimation("pailide")
        end, 

        timeline=
        {
            TimeEvent(15*FRAMES, function(inst) 
                inst:PerformBufferedAction() 
                inst.sg:RemoveStateTag("prehammer") 
            end),

         TimeEvent(18*FRAMES, function(inst)
           if (TheInput:IsControlPressed(CONTROL_SECONDARY) or
                  TheInput:IsControlPressed(CONTROL_ACTION) or TheInput:IsControlPressed(CONTROL_CONTROLLER_ALTACTION)) and 
                  inst.sg.statemem.action and 
                  inst.sg.statemem.action.target and 
                  inst.sg.statemem.action.target:IsActionValid(inst.sg.statemem.action.action, true) and 
                  inst.sg.statemem.action.target.components.workable then
                  inst:ClearBufferedAction()
                  inst:PushBufferedAction(inst.sg.statemem.action)
          end
    end),
  
         TimeEvent(35*FRAMES, function(inst)
                   SpawnPrefab("bluelight").Transform:SetPosition(inst.Transform:GetWorldPosition())
                   inst.components.playercontroller:ShakeCamera(inst, "VERTICAL", 0.3, 0.01, 0.6, 30)          
         end),

        },
        
        onexit = function(inst)
                    if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil then
                          inst.AnimState:Hide("ARM_normal") --隐藏持物手
                          inst.AnimState:Show("ARM_carry") --显示普通的手
                    end
        end, 

        events=
        {
            EventHandler("unequip", function(inst) inst.sg:GoToState("idle") end ),
            EventHandler("animover", function(inst)
			      if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) ~= nil then
                 inst.AnimState:Hide("ARM_normal") --隐藏持物手
                 inst.AnimState:Show("ARM_carry") --显示普通的手
            end
                inst.sg:GoToState("idle", true)
            end ),
        },        
    },
}

for k,v in ipairs(newstates)do
      AddStategraphState("wilson", v)
      AddStategraphState("wilsonboating",v)  
end    

AddStategraphActionHandler("wilson",  ActionHandler(ACTIONS.DEPLOY,
        function(inst, action)
                 if inst.prefab == "edwardelric" then
                       return "pailide_short"
                else       
                return "doshortaction"
            end  
end))

AddStategraphActionHandler("wilson",  ActionHandler(ACTIONS.DEPLOY_AT_RANGE,
        function(inst, action)
                 if inst.prefab == "edwardelric" then
                       return "pailide_short"
                else       
                return "doshortaction"
            end 
end))

AddStategraphActionHandler("wilson",  ActionHandler(ACTIONS.PLANT,
        function(inst, action)
                 if inst.prefab == "edwardelric" then
                       return "pailide_short"
                else       
                return "doshortaction"
            end  
end))
  --施肥动作变成拍手
AddStategraphActionHandler("wilson",  ActionHandler(ACTIONS.FERTILIZE,
        function(inst, action)
                 if inst.prefab == "edwardelric" then
                       return "pailide_short"
                else       
                return "doshortaction"
            end  
end))

AddStategraphActionHandler("wilson",  ActionHandler(ACTIONS.BUILD,
          function(inst, action)
            if not inst.sg:HasStateTag("busy") then
                if action.recipe and action.recipe == "livinglog" and action.doer and action.doer.prefab == "wormwood" then
                    return "form_log"

                elseif inst.prefab == "edwardelric" then
                       return "pailide"
                else       
                return "dolongaction"
            end  
      end
end))

AddStategraphActionHandler("wilsonboating",  ActionHandler(ACTIONS.BUILD,
          function(inst, action)
            if not inst.sg:HasStateTag("busy") then
                if action.recipe and action.recipe == "livinglog" and action.doer and action.doer.prefab == "wormwood" then
                    return "form_log"

                elseif inst.prefab == "edwardelric" then
                       return "pailide"
                else       
                return "dolongaction"
            end  
      end
end))

AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.HAMMER, 
        function(inst)
            if inst.prefab == "edwardelric" then
                    return "pailide_hammer"

            elseif not inst.sg:HasStateTag("prehammer") then 
                if inst.sg:HasStateTag("hammering") then
                    return "hammer"
                else
                    return "hammer_start"
                end
            end 
end))

AddStategraphActionHandler("wilsonboating",  ActionHandler(ACTIONS.HAMMER,
        function(inst)
            if inst.prefab == "edwardelric" then
                    return "pailide_hammer"

            elseif not inst.sg:HasStateTag("prehammer") then
                if inst.sg:HasStateTag("hammering") then
                    return "hammer"
                else
                    return "hammer_start"
                end
          end      
end))

