local MakePlayerCharacter = require "prefabs/player_common"

local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

        Asset( "ANIM", "anim/edwardelric.zip" ),
        Asset( "ANIM", "anim/pailide.zip" ),
        Asset( "ANIM", "anim/pailide_hand.zip" )                
}
local prefabs = {}

local start_inv = {
     --"amulet_shadow"
}

local fn = function(inst)
  inst.MiniMapEntity:SetIcon( "edwardelric.tex" )
  
  inst.soundsname = "woodie"
  inst.components.health:SetMaxHealth(160)
  inst.components.hunger:SetMax(200)
  inst.components.sanity:SetMax(200)
  
    if inst.components.combat.AddDamageModifier ~= nil then
			inst.components.combat:AddDamageModifier("edwardelric",0.5)
		else

			inst.components.combat.damagemultiplier = 1.5
	end

  inst.components.locomotor.walkspeed = 4.5
  inst.components.locomotor.runspeed = 7

  inst:AddComponent("reader")
  inst:AddComponent("edwardelric_rainleg")
  
  inst.components.builder.science_bonus = 1
  
   local _getSanity = inst.components.sanity.DoDelta
                   inst.components.sanity.DoDelta = function(self, delta, overtime) 
                          if delta < 0 then
                                  delta = delta * 0.8
                                                                          
                               elseif  delta > 0 then
                                    delta = delta * 1.2   
                        end                                   
                     return _getSanity(self, delta, overtime) 
         end

   inst:ListenForEvent("buildstructure", function(inst, data)  --建造建筑时产生闪电
   
          if data.item then
				   SpawnPrefab("bluelight").Transform:SetPosition(data.item.Transform:GetWorldPosition())  --在建筑生成的位置放闪电
          end	
   end)	

   local booktab = {str = "BOOKS", sort=998, icon = "tab_book.tex"}
	inst.components.builder:AddRecipeTab(booktab)

	Recipe("book_birds", {Ingredient("papyrus", 2), Ingredient("bird_egg", 2)}, booktab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0})
	Recipe("book_gardening", {Ingredient("papyrus", 2), Ingredient("seeds", 1), Ingredient("poop", 1)}, booktab, {SCIENCE = 1})
	Recipe("book_sleep", {Ingredient("papyrus", 2), Ingredient("nightmarefuel", 2)}, booktab, {MAGIC = 2})
	Recipe("book_brimstone", {Ingredient("papyrus", 2), Ingredient("redgem", 1)}, booktab, {MAGIC = 3})

    if SaveGameIndex:IsModeShipwrecked() then
   		Recipe("book_meteor", {Ingredient("papyrus", 2), Ingredient("obsidian", 2)}, booktab, {SCIENCE = 3})
    else
      	Recipe("book_tentacles", {Ingredient("papyrus", 2), Ingredient("tentaclespots", 1)}, booktab, {SCIENCE = 3})
    end
	
    local oldmake = inst.components.builder.MakeRecipe  --更改制造距离
         function inst.components.builder:MakeRecipe(recipe, pt, rot, onsuccess)
                if recipe then
                       recipe.distance = 12  --制造距离
         end

      return oldmake(self, recipe, pt, rot, onsuccess)
    end 

   local old = inst.components.builder.DoBuild
         function inst.components.builder:DoBuild(recname, pt, rotation)
              if recname == "butter" then
                      inst.components.inventory:GiveItem(SpawnPrefab("smallmeat_dried"))
					  
                  elseif recname == "ice" then
                      inst.components.inventory:GiveItem(SpawnPrefab("charcoal"))
					  
				  elseif recname == "silk" then
					  inst.components.inventory:GiveItem(SpawnPrefab("houndstooth"))
					  
                  elseif recname == "pigskin" then
                      inst.components.inventory:GiveItem(SpawnPrefab("smallmeat_dried"))

                  elseif recname == "lightbulb" then
                      inst.components.inventory:GiveItem(SpawnPrefab("rottenegg")) 
                      inst.components.inventory:GiveItem(SpawnPrefab("rottenegg"))

                      elseif recname == "goldnugget" then
                            inst.components.inventory:GiveItem(SpawnPrefab("houndstooth")) 

                      elseif recname == "gears" then
                            inst.components.inventory:GiveItem(SpawnPrefab("houndstooth"))
                            inst.components.inventory:GiveItem(SpawnPrefab("smallmeat_dried"))
                            inst.components.inventory:GiveItem(SpawnPrefab("smallmeat_dried"))

                      elseif recname == "thulecite_pieces" then 
                            inst.components.inventory:GiveItem(SpawnPrefab("rocks"))
                            inst.components.inventory:GiveItem(SpawnPrefab("rocks"))

                        elseif recname == "resurr_edward" then 
                                     inst.components.sanity:DoDelta(-150,true)
                                        for i = 1, 10 do 
                                                 inst.components.inventory:GiveItem(SpawnPrefab("nightmarefuel"))
                                     end                        

        end  

           if recname == "marble" or recname == "gears" or recname == "redgem" or recname == "bluegem" or recname == "thulecite" then
                     inst.components.sanity:DoDelta(-15,true)

                   elseif recname == "livinglog" then
                            inst.components.sanity:DoDelta(-25,true)
                            inst.components.health:DoDelta(-20,true) 
				   elseif recname == "goldnugget" then
							inst.components.sanity:DoDelta(-10,true)
        end 

      return old(self, recname, pt, rotation)
  end     

   -------------------------------------------------------- 
 if TUNING.SKILL_FOUR then    
    TheInput:AddKeyUpHandler(TUNING.SKILL_FOUR, function()

       local screen = TheFrontEnd:GetActiveScreen()
       local IsHUDActive = screen and screen.name == "HUD"

        if inst.components.hunger.current >= 10 and inst.components.sanity.current >= 5 and IsHUDActive then
                   inst.sg:GoToState("pailide_short")
                   inst.SoundEmitter:PlaySound("pailide/sfx/pailide")
                   inst.components.hunger:DoDelta(-10,true)
                   inst.components.sanity:DoDelta(-5,true)
		
        local facing_angle = GetPlayer().Transform:GetRotation()  --获取玩家面朝的角度来决定冲击波发射的位置

                         if (facing_angle >= 0 and facing_angle < 1) or (facing_angle <= 0 and facing_angle > -1) then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(10, 0, 0)  --10距离，距离越大，冲击波越远                                   

                       elseif facing_angle > 0 and facing_angle <= 46 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(10, 0, -10)                                                       

                       elseif facing_angle > 46 and facing_angle <= 91 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(0, 0, -10)                                                                   

                       elseif facing_angle > 91 and facing_angle <= 136 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-10, 0, -10)

                       elseif (facing_angle > 136 and facing_angle <= 181) or (facing_angle < -136 and facing_angle >= -180) then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-10, 0, 0)
                                                                             
                       elseif facing_angle < 0 and facing_angle >= -46 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(10, 0, 10)                                            

                       elseif facing_angle < -46 and facing_angle >= -91 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(0, 0, 10)
                                                                                

                       elseif facing_angle < -91 and facing_angle >= -136 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-10, 0, 10)
                     end

      inst:DoTaskInTime(0.7, function() 
              local pig = SpawnPrefab("flint")
              pig:Hide()
              pig.Transform:SetPosition(inst.weizhi:Get())

              local fx = SpawnPrefab("blowdart_sleep")
              fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			  fx.persists = false  --游戏退出时不保存该实体，节省游戏内存
			  fx.components.inventoryitem.canbepickedup = false		--技能造出的吹箭无法拾取
			  fx.components.inventoryitem.cangoincontainer = false   --技能造出的吹箭无法到背包
              fx.components.projectile:Throw(inst, pig)
              fx.components.projectile.onhit = function()
                       pig:Remove()
                       fx:Remove()
                      if fx.hittask then
                             fx.hittask:Cancel()
                             fx.hittask = nil      
                   end     
              end
              fx:Hide()

            fx.hittask = fx:DoPeriodicTask(0, function()
                   local pt = Vector3(fx.Transform:GetWorldPosition())

             local fx2 = SpawnPrefab("groundpound_fx")
             local fx3 = SpawnPrefab("groundpoundring_fx")

             fx2.Transform:SetPosition(fx.Transform:GetWorldPosition())
             fx3.Transform:SetPosition(fx.Transform:GetWorldPosition())
             fx3.Transform:SetScale(0.5, 0.5, 0.5)  --冲击波特效缩放50%

                   for k, v in pairs(TheSim:FindEntities(pt.x, pt.y, pt.z, 3)) do
                            if v.components.workable and v.components.workable.action ~= ACTIONS.NET then
                                    v.components.workable:Destroy(inst)
                        end 

                  if v ~= fx and v.components.health and v.components.combat and not v:HasTag("player") and not v:HasTag("beizou") then 
                         v.components.combat:GetAttacked(GetPlayer(), 85)
                         v:AddTag("beizou")
                         v:DoTaskInTime(0.6, function()   -- 伤害计算间隔
                               v:RemoveTag("beizou")
                         end) 
                    end       
                end
            end)
            end)
        else
                  inst.components.talker:Say("可恶，连炼成的力气都没有了吗？")
		end     
    end)
end       

if TUNING.SKILL_ONE1 then
    TheInput:AddKeyUpHandler(TUNING.SKILL_ONE1, function()

       local screen = TheFrontEnd:GetActiveScreen()
       local IsHUDActive = screen and screen.name == "HUD"

        if inst.components.inventory:Has("rocks", 18) and IsHUDActive then
        	  if inst.components.hunger.current >= 10 and inst.components.sanity.current >= 5 then  --释放技能前判断下饥饿值和san是否满足条件

        	  	        inst.components.hunger:DoDelta(-10,true)  --满足的话扣除对应的数值
                        inst.components.sanity:DoDelta(-5,true)

          -----------------技能释放前先初始化数值
             inst.left = 0
             inst.weizhi = 0
             inst.leftpos = 0 
             inst.rightpos = 0

             inst.sg:GoToState("pailide_short")
             inst.SoundEmitter:PlaySound("pailide/sfx/pailide")
             inst.components.inventory:ConsumeByName("rocks", 18)

             local facing_angle = GetPlayer().Transform:GetRotation()
               inst:DoTaskInTime(0.8, function()  --更快的执行相关代码
                  for i = 1, 4 do        
                               inst.left = inst.left + 1       

                        if (facing_angle >= 0 and facing_angle < 1) or (facing_angle <= 0 and facing_angle > -1) then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(1, 0, 0)

                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(0, 0, inst.left) 
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(0, 0, -inst.left)                                    

                       elseif facing_angle > 0 and facing_angle <= 46 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(1, 0, -1)
                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, inst.left)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, -inst.left)                                                          

                       elseif facing_angle > 46 and facing_angle <= 91 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(0, 0, -1) 

                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, 0)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, 0)                                                                   

                       elseif facing_angle > 91 and facing_angle <= 136 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-1, 0, -1)

                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, -inst.left)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, inst.left)
                                                 

                       elseif (facing_angle > 136 and facing_angle <= 181) or (facing_angle < -136 and facing_angle >= -180) then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-1, 0, 0)

                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(0, 0, inst.left)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(0, 0, -inst.left)
                                                                             

                       elseif facing_angle < 0 and facing_angle >= -46 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(1, 0, 1)
                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, -inst.left)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, inst.left)                                             

                       elseif facing_angle < -46 and facing_angle >= -91 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(0, 0, 1)
                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, 0)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, 0)
                                                                                

                       elseif facing_angle < -91 and facing_angle >= -136 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-1, 0,1)

                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, inst.left)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, -inst.left)  
                                end 

                      local tile = inst:GetCurrentTileType(inst.weizhi:Get())
                         if not GetWorld().Map:IsWater(tile) and tile ~= GROUND.IMPASSABLE and tile < GROUND.UNDERGROUND then
                                  if inst.left == 1 then
                                             local fx = SpawnPrefab("wall_stone")
                                             fx:AddTag("skill_wall")
                                             fx.animbuild = true
                                             fx.Transform:SetPosition(inst.weizhi:Get())
                                             fx.SoundEmitter:KillAllSounds()
                                             fx.AnimState:SetBuild("wall_ruins")  --更改动画
											 fx.components.health:SetPercent(1)
                                end                    
                                             local tile2 = inst:GetCurrentTileType(inst.leftpos:Get())
                                             local tile3 = inst:GetCurrentTileType(inst.rightpos:Get())

                                                if not GetWorld().Map:IsWater(tile2) and tile2 ~= GROUND.IMPASSABLE and tile2 < GROUND.UNDERGROUND then 
                                                                local fx2 = SpawnPrefab("wall_stone")
                                                                fx2:AddTag("skill_wall")
                                                                fx2.animbuild = true
                                                                fx2.Transform:SetPosition(inst.leftpos:Get())
                                                                fx2.SoundEmitter:KillAllSounds()
                                                                fx2.AnimState:SetBuild("wall_ruins")
																fx2.components.health:SetPercent(1)

                                               end                 

                                                if not GetWorld().Map:IsWater(tile3) and tile3 ~= GROUND.IMPASSABLE and tile3 < GROUND.UNDERGROUND then 
                                                                local fx3 = SpawnPrefab("wall_stone")
                                                                fx3:AddTag("skill_wall")
                                                                fx3.animbuild = true
                                                                fx3.Transform:SetPosition(inst.rightpos:Get())
                                                                fx3.SoundEmitter:KillAllSounds()
                                                                fx3.AnimState:SetBuild("wall_ruins")
																fx3.components.health:SetPercent(1)
                                        end  
                                   if inst.left == 3 then
                                          SpawnPrefab("bluelight").Transform:SetPosition(inst.leftpos:Get())
                                          SpawnPrefab("bluelight").Transform:SetPosition(inst.rightpos:Get())        
                             end
                        end
                    end
              end)
           else
                 inst.components.talker:Say("可恶，连炼成的力气都没有了吗？") --饥饿或san值不足时
         end    

              else
                 inst.components.talker:Say("我需要更多的石头！")
           end                      
     end)
end

-----------------------------------------
if TUNING.SKILL_ONE2 then
TheInput:AddKeyUpHandler(TUNING.SKILL_ONE2, function()

       local screen = TheFrontEnd:GetActiveScreen()
       local IsHUDActive = screen and screen.name == "HUD"

        if inst.components.inventory:Has("rocks", 18) and IsHUDActive then

        	  if inst.components.hunger.current >= 10 and inst.components.sanity.current >= 5 then  

        	  	        inst.components.hunger:DoDelta(-10,true)
                        inst.components.sanity:DoDelta(-5,true)

          -----------------
             inst.left = 0
             inst.weizhi = 0
             inst.leftpos = 0 
             inst.rightpos = 0
             inst.sg:GoToState("pailide")
             inst.SoundEmitter:PlaySound("pailide/sfx/pailide")
             inst.components.inventory:ConsumeByName("rocks", 14)

             local facing_angle = GetPlayer().Transform:GetRotation()
                inst:DoTaskInTime(1.3, function()   --1.3秒后
                  for i = 1, 4 do        
                               inst.left = inst.left + 1       

                        if (facing_angle >= 0 and facing_angle < 1) or (facing_angle <= 0 and facing_angle > -1) then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(8, 0, 0)

                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(0, 0, inst.left) 
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(0, 0, -inst.left)                                    

                       elseif facing_angle > 0 and facing_angle <= 46 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(8, 0, -8)
                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, inst.left)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, -inst.left)                                                          

                       elseif facing_angle > 46 and facing_angle <= 91 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(0, 0, -8) 

                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, 0)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, 0)                                                                   

                       elseif facing_angle > 91 and facing_angle <= 136 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-8, 0, -8)

                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, -inst.left)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, inst.left)
                                                 

                       elseif (facing_angle > 136 and facing_angle <= 181) or (facing_angle < -136 and facing_angle >= -180) then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-8, 0, 0)

                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(0, 0, inst.left)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(0, 0, -inst.left)
                                                                             

                       elseif facing_angle < 0 and facing_angle >= -46 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(8, 0, 8)
                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, -inst.left)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, inst.left)                                             

                       elseif facing_angle < -46 and facing_angle >= -91 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(0, 0, 8)
                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, 0)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, 0)
                                                                                

                       elseif facing_angle < -91 and facing_angle >= -136 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-8, 0, 8)

                                             inst.leftpos = Vector3(inst.weizhi:Get()) + Vector3(inst.left, 0, inst.left)  --
                                             inst.rightpos = Vector3(inst.weizhi:Get()) + Vector3(-inst.left, 0, -inst.left)  
                                end                                                                                         

                      local tile = inst:GetCurrentTileType(inst.weizhi:Get())
                         if not GetWorld().Map:IsWater(tile) and tile ~= GROUND.IMPASSABLE and tile < GROUND.UNDERGROUND then
                                  if inst.left == 1 then
                                             local fx = SpawnPrefab("wall_stone")
                                             fx:AddTag("skill_wall")
                                             fx.animbuild = true
                                             fx.Transform:SetPosition(inst.weizhi:Get())
                                             fx.AnimState:SetBuild("wall_ruins")
                                             fx.SoundEmitter:KillAllSounds() 
											 fx.components.health:SetPercent(1)
                                end                    
                                             local tile2 = inst:GetCurrentTileType(inst.leftpos:Get())
                                             local tile3 = inst:GetCurrentTileType(inst.rightpos:Get())
                                             print("是"..inst.leftpos:Get())

                                                if not GetWorld().Map:IsWater(tile2) and tile2 ~= GROUND.IMPASSABLE and tile2 < GROUND.UNDERGROUND then 
                                                                local fx2 = SpawnPrefab("wall_stone")
                                                                fx2:AddTag("skill_wall")
                                                                fx2.animbuild = true
                                                                fx2.Transform:SetPosition(inst.leftpos:Get())
                                                                fx2.AnimState:SetBuild("wall_ruins")
                                                                fx2.SoundEmitter:KillAllSounds() 
																fx2.components.health:SetPercent(1)
                                               end                 

                                                if not GetWorld().Map:IsWater(tile3) and tile3 ~= GROUND.IMPASSABLE and tile3 < GROUND.UNDERGROUND then 
                                                                local fx3 = SpawnPrefab("wall_stone")
                                                                fx3:AddTag("skill_wall")
                                                                fx3.animbuild = true
                                                                fx3.Transform:SetPosition(inst.rightpos:Get())
                                                                fx3.AnimState:SetBuild("wall_ruins")
                                                                fx3.SoundEmitter:KillAllSounds() 
																fx3.components.health:SetPercent(1)
                                        end 

                                   if inst.left == 3 then
                                          SpawnPrefab("bluelight").Transform:SetPosition(inst.leftpos:Get())
                                          SpawnPrefab("bluelight").Transform:SetPosition(inst.rightpos:Get())        
                             end

                      end
               end
          end)  

           else
                 inst.components.talker:Say("可恶，连炼成的力气都没有了吗？") --饥饿或san值不足时
      end 
              else
                 inst.components.talker:Say("我需要更多的石头！")
           end                      
     end)
end
---------------------------------------------------------
---------------------------------------------------------
--[[以自身为中心生成石头]]
if TUNING.SKILL_TWO1 then
TheInput:AddKeyUpHandler(TUNING.SKILL_TWO1, function()

       local screen = TheFrontEnd:GetActiveScreen()
       local IsHUDActive = screen and screen.name == "HUD"

    if inst.components.inventory:Has("rocks",14) and IsHUDActive then

        	  if inst.components.hunger.current >= 5 and inst.components.sanity.current >= 5 then  --释放技能前判断下饥饿值和san是否满足条件

        	  	        inst.components.hunger:DoDelta(-5,true)  --满足的话扣除对应的数值
                        inst.components.sanity:DoDelta(-5,true)

       inst.left = 0
       inst.sg:GoToState("pailide_short")
       inst.SoundEmitter:PlaySound("pailide/sfx/pailide")
       inst.components.inventory:ConsumeByName("rocks", 12)

        inst:DoTaskInTime(0.8, function()   --0.8秒后
          for i = 1, 4 do
               inst.left = inst.left + 1
               local pos = Vector3(GetPlayer().Transform:GetWorldPosition())

               local heng = Vector3(pos:Get()) + Vector3(-1, 0, GetPlayer().left-2)  --
               local heng2 = Vector3(pos:Get()) + Vector3(2, 0, GetPlayer().left-2)
               local shu = Vector3(pos:Get()) + Vector3(GetPlayer().left-2, 0, -1)
               local shu2 = Vector3(pos:Get()) + Vector3(GetPlayer().left-2, 0, 2)

                 local fx = SpawnPrefab("wall_stone")
                 local fx2 = SpawnPrefab("wall_stone")
                 local fx3 = SpawnPrefab("wall_stone")
                 local fx4 = SpawnPrefab("wall_stone")

                     fx.Transform:SetPosition(heng:Get())
                     fx2.Transform:SetPosition(heng2:Get())

                     fx.animbuild = true
                     fx2.animbuild = true

                      if GetPlayer().left <= 3 then
                             fx3.Transform:SetPosition(shu:Get())  --边上只生成一个就能组成4*4的墙了 
                             fx3.animbuild = true 

                             fx4.Transform:SetPosition(shu2:Get())
                             fx4.animbuild = true  
                      end       

                     fx.AnimState:SetBuild("wall_ruins")  --更改石墙外观
                     fx2.AnimState:SetBuild("wall_ruins")
                     fx3.AnimState:SetBuild("wall_ruins")
                     fx4.AnimState:SetBuild("wall_ruins")

                         if GetPlayer().left == 0 or GetPlayer().left == 4 then  --只在边角位置生成闪电   原 1 3
                                SpawnPrefab("bluelight").Transform:SetPosition(heng:Get())
                                SpawnPrefab("bluelight").Transform:SetPosition(heng2:Get())
                      end                     
                 end
           end)

           else
                 inst.components.talker:Say("可恶，连炼成的力气都没有了吗？") --饥饿或san值不足时
         end   

        else
                  inst.components.talker:Say("我需要更多的石头！")
      end     
end)
end


if TUNING.SKILL_TWO2 then
TheInput:AddKeyUpHandler(TUNING.SKILL_TWO2, function()

       local screen = TheFrontEnd:GetActiveScreen()
       local IsHUDActive = screen and screen.name == "HUD"

    if inst.components.inventory:Has("rocks", 56) and IsHUDActive then

        	  if inst.components.hunger.current >= 25 and inst.components.sanity.current >= 20 then  --释放技能前判断下饥饿值和san是否满足条件

        	  	        inst.components.hunger:DoDelta(-25,true)  --满足的话扣除对应的数值
                        inst.components.sanity:DoDelta(-20,true)

       GetPlayer().left = 0
       inst.sg:GoToState("pailide")
       inst.SoundEmitter:PlaySound("pailide/sfx/pailide")
       inst.components.inventory:ConsumeByName("rocks", 56)

      inst:DoTaskInTime(1.3, function()   --1.2秒后   
          for i = 1, 14 do
               GetPlayer().left = GetPlayer().left + 1
               local pos = Vector3(GetPlayer().Transform:GetWorldPosition())

               local heng = Vector3(pos:Get()) + Vector3(-6, 0, GetPlayer().left-7)  --
               local heng2 = Vector3(pos:Get()) + Vector3(7, 0, GetPlayer().left-7)
               local shu = Vector3(pos:Get()) + Vector3(GetPlayer().left-7, 0, -6)
               local shu2 = Vector3(pos:Get()) + Vector3(GetPlayer().left-7, 0, 7)

                 local fx = SpawnPrefab("wall_stone")
                 local fx2 = SpawnPrefab("wall_stone")
                 local fx3 = SpawnPrefab("wall_stone")
                 local fx4 = SpawnPrefab("wall_stone")

                     fx.Transform:SetPosition(heng:Get())
                     fx2.Transform:SetPosition(heng2:Get())

                     fx.animbuild = true
                     fx2.animbuild = true  
 
                        if GetPlayer().left <= 15 then
                                 fx3.Transform:SetPosition(shu:Get()) 
                                 fx4.Transform:SetPosition(shu2:Get())

                                 fx3.animbuild = true
                                 fx4.animbuild = true    
                        end

                     fx.AnimState:SetBuild("wall_ruins")  --更改石墙外观
                     fx2.AnimState:SetBuild("wall_ruins")
                     fx3.AnimState:SetBuild("wall_ruins")
                     fx4.AnimState:SetBuild("wall_ruins")

                         if GetPlayer().left == 12 or GetPlayer().left == 0 then            
                                SpawnPrefab("bluelight").Transform:SetPosition(heng:Get())
                                SpawnPrefab("bluelight").Transform:SetPosition(heng2:Get())
                      end
                end
           end)
           else
                 inst.components.talker:Say("可恶，连炼成的力气都没有了吗？") --饥饿或san值不足时
         end   

        else
                  inst.components.talker:Say("我需要更多的石头！")
      end     
end)
end
------------------------------------------------------------------
print(GetPlayer().Transform:GetRotation())

if TUNING.SKILL_THREE1 then
TheInput:AddKeyUpHandler(TUNING.SKILL_THREE1, function()

       local screen = TheFrontEnd:GetActiveScreen()
       local IsHUDActive = screen and screen.name == "HUD"

     if inst.components.inventory:Has("rocks", 20) and IsHUDActive then

        	  if inst.components.hunger.current >= 10 and inst.components.sanity.current >= 10 then  --释放技能前判断下饥饿值和san是否满足条件

        	  	        inst.components.hunger:DoDelta(-10,true)  --满足的话扣除对应的数值
                        inst.components.sanity:DoDelta(-10,true)

                 inst.sg:GoToState("pailide_short") 
                 inst.SoundEmitter:PlaySound("pailide/sfx/pailide")
                 inst.components.inventory:ConsumeByName("rocks", 20)

        local facing_angle = GetPlayer().Transform:GetRotation()

                      if (facing_angle >= 0 and facing_angle < 1) or (facing_angle <= 0 and facing_angle > -1) then
                                 GetPlayer().weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(2, 0, -2.5) --减， 不变                                 

                       elseif facing_angle > 0 and facing_angle <= 46 then
                                 GetPlayer().weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(1, 0, -6)  --减加                                                      

                       elseif facing_angle > 46 and facing_angle <= 91 then
                                 GetPlayer().weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-2.5, 0, -7)  --不变, 加                                                                 

                       elseif facing_angle > 91 and facing_angle <= 136 then
                                 GetPlayer().weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-7, 0, -7)  --加， 加                                              

                       elseif (facing_angle > 136 and facing_angle <= 181) or (facing_angle < -136 and facing_angle >= -180) then
                                 GetPlayer().weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-9, 0, -2.5)  --减, 不变                                                                          

                       elseif facing_angle < 0 and facing_angle >= -46 then
                                 GetPlayer().weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(2.5, 0, 2.5)  --减，减                                           

                       elseif facing_angle < -46 and facing_angle >= -91 then
                                 GetPlayer().weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-2.5, 0, 5) 
                                                                                
                       elseif facing_angle < -91 and facing_angle >= -136 then
                                 GetPlayer().weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-7, 0, 2) --加， 不变
                      end

                 inst:DoTaskInTime(0.8, function()   --0.8秒后  
                      local fx0 = SpawnPrefab("wall_stone")   
                      fx0.Transform:SetPosition(inst.weizhi:Get())
                      fx0.AnimState:SetBuild("wall_ruins")
                      fx0.animbuild = true  

       GetPlayer().left = 0
          for i = 1, 5 do
               GetPlayer().left = GetPlayer().left + 1
               local heng = Vector3(GetPlayer().weizhi:Get()) + Vector3(GetPlayer().left, 0, 0)  --
               local heng2 = Vector3(GetPlayer().weizhi:Get()) + Vector3(0, 0, GetPlayer().left)
               local shu = Vector3(GetPlayer().weizhi:Get()) + Vector3(5, 0, GetPlayer().left)
               local shu2 = Vector3(GetPlayer().weizhi:Get()) + Vector3(GetPlayer().left, 0, 5) 

                 local fx = SpawnPrefab("wall_stone")
                 local fx2 = SpawnPrefab("wall_stone")
                 local fx3 = SpawnPrefab("wall_stone")
                 local fx4 = SpawnPrefab("wall_stone")

                     fx.Transform:SetPosition(heng:Get())
                     fx2.Transform:SetPosition(heng2:Get())
                     fx3.Transform:SetPosition(shu:Get()) 
                     fx4.Transform:SetPosition(shu2:Get())

                     fx.animbuild = true 
                     fx2.animbuild = true 
                     fx3.animbuild = true 
                     fx4.animbuild = true                                                                                     

                     fx.AnimState:SetBuild("wall_ruins")
                     fx2.AnimState:SetBuild("wall_ruins")
                     fx3.AnimState:SetBuild("wall_ruins")
                     fx4.AnimState:SetBuild("wall_ruins")
                         if GetPlayer().left == 5 then    
                                SpawnPrefab("bluelight").Transform:SetPosition(heng:Get())
                                SpawnPrefab("bluelight").Transform:SetPosition(heng2:Get())
                                SpawnPrefab("bluelight").Transform:SetPosition(shu:Get()) 
                                SpawnPrefab("bluelight").Transform:SetPosition(shu2:Get())
                       end  	
                   end
              end) 

           else
                 inst.components.talker:Say("可恶，连炼成的力气都没有了吗？") --饥饿或san值不足时
         end   

          else
                  inst.components.talker:Say("我需要更多的石头！")
       end   
end)
end   
---------------------------------------------
if TUNING.SKILL_THREE2 then
TheInput:AddKeyUpHandler(TUNING.SKILL_THREE2, function()

       local screen = TheFrontEnd:GetActiveScreen()
       local IsHUDActive = screen and screen.name == "HUD"

     if inst.components.inventory:Has("rocks", 20) and IsHUDActive then

        	  if inst.components.hunger.current >= 10 and inst.components.sanity.current >= 10 then  --释放技能前判断下饥饿值和san是否满足条件

        	  	        inst.components.hunger:DoDelta(-10,true)  --满足的话扣除对应的数值
                        inst.components.sanity:DoDelta(-10,true)
     	
                 inst.sg:GoToState("pailide")
                 inst.SoundEmitter:PlaySound("pailide/sfx/pailide")
                 inst.components.inventory:ConsumeByName("rocks", 20)

        local facing_angle = GetPlayer().Transform:GetRotation()
                       inst.weizhi = 0

                      if (facing_angle >= 0 and facing_angle < 1) or (facing_angle <= 0 and facing_angle > -1) then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(7, 0, -2.5)--                                 

                       elseif facing_angle > 0 and facing_angle <= 46 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(6, 0, -11)                                                        

                       elseif facing_angle > 46 and facing_angle <= 91 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-2.5, 0, -14)                                                                 

                       elseif facing_angle > 91 and facing_angle <= 136 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-11, 0, -11)                                                

                       elseif (facing_angle > 136 and facing_angle <= 181) or (facing_angle < -136 and facing_angle >= -180) then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-13, 0, -2.5)                                                                           

                       elseif facing_angle < 0 and facing_angle >= -46 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(5.5, 0, 5.5)                                            

                       elseif facing_angle < -46 and facing_angle >= -91 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-2.5, 0, 8)
                                                                                
                       elseif facing_angle < -91 and facing_angle >= -136 then
                                 inst.weizhi = Vector3(GetPlayer().Transform:GetWorldPosition()) + Vector3(-11, 0, 6) 
                      end

   inst:DoTaskInTime(1.3, function()   --1.3秒后
                      local fx5 = SpawnPrefab("wall_stone") 
                      fx5.Transform:SetPosition(inst.weizhi:Get())
                      fx5.AnimState:SetBuild("wall_ruins")


       GetPlayer().left = 0
          for i = 1, 5 do
               GetPlayer().left = GetPlayer().left + 1
               local heng = Vector3(GetPlayer().weizhi:Get()) + Vector3(GetPlayer().left, 0, 0)  --
               local heng2 = Vector3(GetPlayer().weizhi:Get()) + Vector3(0, 0, GetPlayer().left)
               local shu = Vector3(GetPlayer().weizhi:Get()) + Vector3(5, 0, GetPlayer().left)
               local shu2 = Vector3(GetPlayer().weizhi:Get()) + Vector3(GetPlayer().left, 0, 5) 

                 local fx = SpawnPrefab("wall_stone")
                 local fx2 = SpawnPrefab("wall_stone")
                 local fx3 = SpawnPrefab("wall_stone")
                 local fx4 = SpawnPrefab("wall_stone")

                     fx.Transform:SetPosition(heng:Get())
                     fx2.Transform:SetPosition(heng2:Get())
                     fx3.Transform:SetPosition(shu:Get()) 
                     fx4.Transform:SetPosition(shu2:Get())

                     fx.animbuild = true 
                     fx2.animbuild = true
                     fx3.animbuild = true 
                     fx4.animbuild = true                                                                                     

                     fx.AnimState:SetBuild("wall_ruins")
                     fx2.AnimState:SetBuild("wall_ruins")
                     fx3.AnimState:SetBuild("wall_ruins")
                     fx4.AnimState:SetBuild("wall_ruins")
					 
                        if GetPlayer().left == 5 then
                                SpawnPrefab("bluelight").Transform:SetPosition(heng:Get())
                                SpawnPrefab("bluelight").Transform:SetPosition(heng2:Get())
                                SpawnPrefab("bluelight").Transform:SetPosition(shu:Get()) 
                                SpawnPrefab("bluelight").Transform:SetPosition(shu2:Get())
                      end
            end
    end)  

           else
                 inst.components.talker:Say("可恶，连炼成的力气都没有了吗？") --饥饿或san值不足时
         end   

           else
                  inst.components.talker:Say("我需要更多的石头！")
       end   
end)
end

end

return MakePlayerCharacter("edwardelric", prefabs, assets, fn, start_inv)